#!/usr/bin/perl -w

use DBI();

$database = "kymesonet";
$dsn = "DBI:mSQL:$database";

$con = DBI->connect($dsn) ||
    die "Unable to connect $database $tbname:$DBI::errstr ";
    
@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL);
@dbdata = qw(utme ltme tair dprc relh tdpt wspd wdir wsmx srad);

$stid = "HTFD";
$tbname = $stid . "_H";

#2008022123
$ddate = "20080221";
$utme = $ddate . "23";
#$utme = "2008022123";
&read_db_data;

if (@query_out) { 
#	 $string = "@query_out";
#	 if ($string =~ /9.99/||$string =~ /999/||$string =~ /999.9/){	     
	     &find_missing_data; 
#	 }
}


#
$con ->disconnect;

##

sub read_db_data
{
	
$query = "select * from $tbname where utme=$utme";
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
print "query_out:@query_out\n";


$sth->finish;
	
}	


sub find_missing_data
{

$j = 0;    
foreach $ss(@query_out){
    	  if ($ss =~ /9.99/||$ss =~ /999/||$ss =~ /999.9/){
    	      print "$j:$ss\n";
    	      &update_db1;
    	  }	
    	  $j++;   
}
	
}

sub update_db
{
$tair = 999.9;
$relh = 999;
$dprc = 9.99;
$tdpt = 999.9;
$wspd = 999.9;
$wdir = 999;
$wsmx = 999.9;
$srad = 999.9;

# update $tbname set tair=50.9 where utme=$utme
$query = "update $tbname set ";
if ($j == 2){ $query .= "tair=$tair";}
elsif ($j == 3){ $query .= "dprc=$dprc"; }
elsif ($j == 4){ $query .= "relh=$relh"; }
elsif ($j == 5){ $query .= "tdpt=$tdpt"; }
elsif ($j == 6){ $query .= "wspd=$wspd"; }
elsif ($j == 7){ $query .= "wdir=$wdir"; }
elsif ($j == 8){ $query .= "wsmx=$wsmx"; }
elsif ($j == 9){ $query .= "srad=$srad"; }

$query .= " where utme=$utme";

print "$query\n";

#$con->do($query);
	
}

#
sub update_db1
{

$tair = 999.9;
$relh = 999;
$dprc = 9.99;
$tdpt = 999.9;
$wspd = 999.9;
$wdir = 999;
$wsmx = 999.9;
$srad = 999.9;


# update $tbname set tair=50.9 where utme=$utme
$query = "update $tbname set ";
# $dbdata[$j]
$dd = $dbdata[$j];
print "dd:$dd\n";

$dd1 = ${$dd};
print "dd1:$dd1\n";


#if ($j == 2){ if($tair == 999.9){ return; } $query .= "tair=$tair"; }
#elsif ($j == 3){ if($dprc == 9.99){ return; } $query .= "dprc=$dprc"; }
#elsif ($j == 4){ if($relh == 999){ return; } $query .= "relh=$relh"; }
#elsif ($j == 5){ if($tdpt == 999.9){ return; } $query .= "tdpt=$tdpt"; }
#elsif ($j == 6){ if($wspd == 999.9){ return; } $query .= "wspd=$wspd"; }
#elsif ($j == 7){ if($wdir == 999){ return; } $query .= "wdir=$wdir"; }
#elsif ($j == 8){ if($wsmx == 999.9){ return; } $query .= "wsmx=$wsmx"; }
#elsif ($j == 9){ if($srad == 999.9){ return; } $query .= "srad=$srad"; }

if ($dd1 == 9.99 && $dd1 == 999 && $dd1 == 999.9){ return; }
else {
	    $query .= "$dd=$dd1";
	    $query .= " where utme=$utme";
	    
	    print "$query\n";
	          
      #$con->do($query);
}
	
}
