#!/usr/bin/perl
#

use Scalar::Util qw(looks_like_number);


print "if a string is a number:\n\n";


my @exprs = qw(1 5.25 0.001 1.3e8 foo bar 1dd);

print "The string @exprs\n";


foreach my $expr (@exprs) {
    print "$expr is", looks_like_number($expr) ? '' : ' not', " a number\n";

    if (!looks_like_number($expr)){ print "Not a number: $expr\n\n"; }
}


print "--------------------------------------\n\n";

$xatd = " 10.5";
#$xatd = " nan ";
print "the string : $xatd\n";
#print "looks_like_number($xatd)\n";
#if (!looks_like_number($xatd)){ print "1: not a number\n"; }
#else { $xatd = 32 + 1.8 * $xatd;  }
#$xatd = sprintf("%5.1f",$xatd);

#if ($xatd !~ /^-?\d+\.?\d*$/){ print "2: not a number\n"; }

use Regexp::Common;
if ($xatd !~ /$RE{num}{real}/) { print "3: not a number\n"; }

if ($xatd !~ m/\d/){ print "4: not a number\n"; }

#if ($xatd =~ /\w/){ print "5: not a number\n"; }
 
if ($xatd =~ m/^[a-zA-Z]+$/){ print "6: not a number\n"; }


$dd = IsANumber($xatd);
print "$dd\n";



sub IsANumber {

        my $var = $_[0];
        
        if (

          # contains digits,commas and 1 period
          ($var =~ /(^[0-9]{1,}?$)|(\,*?)|(\.{1})/) &&

          # does not contain alpha's, more than 1 period
          # commas or periods at the beggining and ends of
          # each line
          !($var =~ /([a-zA-Z])|(^[\.\,]|[\.\,]$)/) &&

          # is not null
          ($var ne '')

          ) { return(1) } 
          else { return(0) }
}