#!/usr/bin/perl -w
use LWP::Simple;
use XML::Simple;
use Data::Dumper;
use DBI();

$xml = new XML::Simple;

$database = "kymesonet";
$tbname = "kymn_dl";
$dsn = "DBI:mSQL:$database";

#20080309 - 20081102
$dt_time = "yes";


    
#@sites = qw(FARM HTFD PCWN MRHD MRRY RSVL CMBA CRMT LXGN SCTV PRNC BLRK BMBL PGHL);

#%timezones = ("FARM"->"CST","HTFD"->"CST","PCWN"->"EST","MRHD"->"EST","MRRY"->"CST","RSVL"->"CST");
#%timezones = ("FARM","CST","HTFD","CST","PCWN","EST","MRHD","EST","MRRY","CST","RSVL","CST","CMBA","CST","CRMT","EST","LXGN","EST",
#              "SCTV","CST","PRNC","CST","BLRK","CST","BMBL","EST","PGHL","CST");

&read_kym_sites;


foreach $site(@sites){
	
	      $timezone = $timezones{$site};

	      
	      
	      print "$site,$timezone\n";
      

        #last;
   	
}

#
#&read_kym_sites;


#



sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";

    push(@sites,$site);
    $timezones{$site} = $tm;

    #print "$site,$timezones{$site}\n\n";


}

close(INFILE);


}
