#!/usr/bin/perl -w

$dir = "/data/ldm/data/kymesonet/scripts";
$sfile = "kymesonet_sites";

# print cols
$col = 5;

# Read kymesonet sites, build @sites and @timezones
 &read_kym_sites;

print "\n";
print "@sites\n\n";


#
sub read_kym_sites
{
$kym_sites = "$dir/$sfile";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm,$lat,$lon,$location) = split(/\s+/,$line);

    if ($col == 2) { print "$co,$site\n"; }
    elsif ($col == 3) { print "$co,$site,$tm\n"; }
    elsif ($col == 5) { print "$co,$site,$tm,$lat,$lon\n"; }     

    else { print "$co,$site,$tm,$lat,$lon,$location\n"; }

    push(@sites,$site);
    $timezones{$site} = $tm;
    
    #print "$site,$timezones{$site}\n\n";

}

close(INFILE);

}

