#!/usr/bin/perl -w
#  this script is used to search nearest site for kymesonet 
#  please run: ./search_nearest_site.pl site lat lon
#  ./search_nearest_site.pl Bell 36.77 -83.67
# site: County name For exampple Fayette
#  WH Wang, Mar. 2011
use Math::Trig;


$sdir = "/data/ldm/data/kymesonet/";
#$ddir = "/data/ldm/data/kyallsites/PM";

# data dir
$kymsites = "kymesonet_sites";

if ($ARGV[2]){ 
	  $site0 = $ARGV[0]; chomp($site0);
	  $lat0 = $ARGV[1]; chomp($lat0);
	  $lon0 = $ARGV[2]; chomp($lon0);
} else { print "run: ./search_nearest_site.pl site lat lon\n";   exit; }

#print "$site0,$lat0,$lon0\n";

#	
&read_kymsites;	

#
foreach $co(@sites){
   $lat = $lat{$co};
   $lon = $lon{$co};
   #print "Esimate site: $co,$lat,$lon\n";
   &cal_distance;       
   
}

#@sorted = sort @dists;
#print "@sorted\n";

@sites1 = @sites;
$i = 0;
while($i < 3){      
    &find_nearest_sites;      	      
    if ($nearest != 0){ 
    	  #print "The distance from $site0 to $nco : $nearest\n";
    	  
    	  $nsite = $sids{$nco};
    	  
    	  if ($i == 1){ $printout = $nsite . ":" . $nearest . "," ; }
    	  elsif ($i == 2){ $printout .= $nsite . ":" . $nearest ; }
    } 

    
    @sites2 = "";
    $d1 = 0;
    foreach $ss(@sites1){
    	   if ($ss ne $nco){ 
    	   	   if ($d1 == 0){ @sites2 = $ss; $d1 = 1; }
    	   	   else{ push(@sites2,$ss); }
    	   }
    }	
    	      
    @sites1 = @sites2;
    
    $i++;
    
}

print "$printout\n";

#

#print "\n\n";
#@sorted= sort @sites;
#print "@sorted\n\n";
#foreach $ss(@sorted){ print "$ss\n"; }

##



# read kymesonet_sites file 
sub read_kymsites
{
#COUNTY        SITE TIMEZONE CD LATITUDE LONGITUDE  START     LOCATION
#print "Read $kymsites file...\n";

$file = $sdir . $kymsites;

open (INFILE,"$file");

$i = 0;
while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);
    #print "$line\n";
    
    ($co,$sid,$tz,$lat,$lon,$start,$loc) = split(/\s+/,$line);
    chomp($line);
    
    $loc = trim($loc);    
    $sid = trim($sid);
    $co = trim($co);
    $tz = trim($tz);
    $lat = trim($lat);
    $lon = trim($lon);
    $start = trim($start);  
    
    $sids{$co} = $sid;
    
    if ($i > 0){
        push(@sites,$co);
    
        $lat{$co} = $lat;
        $lon{$co} = $lon;
    }
    #print "$co,$lat,$lon\n";
    
    #$d1 = $data{$co};    
    #$co = sprintf("%-21s",$co);
    #print "$co,$sid,$co,$tz,$lat,$lon\n"; 
    #print "$co,$ddate,$lat,$lon,$d1\n"; 
    #&read_db_data;  	
    
    $i++;     
    
}

close(INFILE);
$i = $i - 1;
#print "Total data readed from $kymsites : $i\n\n";

}	

sub cal_distance
{

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 53.0 * (lon2 - lon1) 
#$x = 69.1 * ($lat - $lats[0]);
#$y = 53.0 * ($lon - $lons[0]);
#$dist = sqrt($x * $x + $y * $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 1: ${cos[0]} to ${co} : ${dist}\n";

#sqrt(x * x + y * y) where x = 69.1 * (lat2 - lat1) and y = 69.1 * (lon2 - lon1) * cos(lat1/57.3) 
$x = 69.1 * ($lat - $lat0);
$y = 69.1 * ($lon - $lon0) * cos($lat0/57.3);
$dist = sqrt($x * $x + $y * $y);
$dist = sprintf("%3.0f",$dist);
$dists{$co} = $dist;
#$dists[$i] = $dist;
#print "$site0 to $co  : $dist\n";
#print "Cal 2: ${cons[0]} to ${co} : ${dist}\n";

#3963.0 * arccos[sin(lat1/57.2958) * sin(lat2/57.2958) + cos(lat1/57.2958) * cos(lat2/57.2958) *  cos(lon2/57.2958 -lon1/57.2958)]
#
#$x = sin($lats[0]/57.2958) * sin($lat/57.2958);
#$y = cos($lats[0]/57.2958) * cos($lat/57.2958);
#$y = $y * cos(($lon -$lons[0]) / 57.2958);
#$dist = 3963.0 * acos($x + $y);
#$dist = sprintf("%7.2f",$dist);
#print "Cal 3: ${cos[0]} to ${co} : ${dist}\n\n";
	
}

sub find_nearest_sites
{

$d1 = 0;
foreach $co(@sites1){
	  
    if ($d1 == 0){ 
    	  $nearest = $dists{$co}; 
    	  $nco = $co; 
    	  $d1 = 1; }
    elsif ($nearest > $dists{$co}){ 
    	     $nearest = $dists{$co}; 
    	     $nco = $co; 
    }	  
 
}	

}

	
#Remov leading or ending whitespace of a string
#$string = trim($string);
#@many   = trim(@many);
sub trim {
    @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}
