#!/usr/bin/perl -w
#  this script update missing data of one site based on related site 
#  WH Wang,20101019
use DBI();

#
$database = "kymesonet";
$tbname = "kymn_dl";
$dsn = "DBI:mSQL:$database";

#$sdir = "/data/ldm/data/kymesonet/scripts";


# 
$con = DBI->connect($dsn) ||
    die "Unable to connect $database $tbname:$DBI::errstr ";

# site of missing data 
$msite = "SCTV";

# site used to update missing data Jackson
$site = "FARM";

# define start date to end date
$sdate = "20100810";
$edate = "20100812";


#
$query = "select * from $tbname where ltme>=$sdate and ltme<=$edate and stid='$site' order by ltme";

#$query = "select * from $tbname where stid='$site' and ltme=$date";
$sth = $con -> prepare($query);
$sth->execute;

while(@query_out = $sth->fetchrow_array){

    #$site = $query_out[0];
    $ddate = $query_out[1];
    $tmx = $query_out[2];  #$tmx = sprintf("%3d", $tmx);
    $tmn = $query_out[3];  #$rh_mn = sprintf("%3d",$rh_mn);
    $prc = $query_out[4]; 
    $hmx = $query_out[5];  #$rh_mx = sprintf("%3d",$rh_mx);
    $hmn = $query_out[6]; #$rh_mn = sprintf("%3d",$rh_mn);
    $atd = $query_out[7];
    $wsa = $query_out[8];
    $wsx = $query_out[9];
       
    #print "$site, $str, $ddate, $tmx, $tmn, $prc, $hmx, $hmn, $atd, $wsa, $wsx\n"; 
     $str = "$site $ddate $tmx $tmn $prc $hmx $hmn $atd $wsa $wsx";     
     print  "$str\n";     
     
    # update site of missing data 
     &update_db;
     
}

$sth->finish;

#
$con ->disconnect;

##

# Update db with data
sub update_db
{

$query = "update $tbname set ";
$query .= "xtmx=$tmx, ";
$query .= "xtmn=$tmn, ";
$query .= "xprc=$prc, ";
$query .= "xhmx=$hmx, ";
$query .= "xhmn=$hmn, ";
$query .= "xatd=$atd, ";
$query .= "xwsa=$wsa, ";
$query .= "xwsx=$wsx ";

$query .= "where stid='$msite' and ltme=$ddate";
#$query="update kymn_dl set xtmx= 82.8, xtmn= 46.2, xprc=0.00, xhmx=   97, xhmn=   28, xatd= 47.7, xwsa=  5.4, xwsx= 24.4 where stid='CRMT' and ltme=20100930";

print "$query\n\n";

# remove # if do update
$cursor = $con->do($query);

print "...updated.\n\n";

}


