#!/usr/bin/perl -w
use DBI;
use DBD::mysql;

# Connect to MySQL
$database = "kymesonet";
$user = "ukagwx";
$pw = "243agwx";

#DATA SOURCE NAME
$dsn = "dbi:mysql:$database:localhost:3306";

# PERL DBI CONNECT
$con = DBI->connect($dsn, $user, $pw) or die "Unable to connect: $DBI::errstr\n";


@dbdata = qw(utme ltme tair dprc relh tdpt wspd wdir wsmx srad);

$tdir = "/data/ldm/data/kymesonet/scripts/tmp/";
#$sdir = "/data/ldm/data/kymesonet/scripts/";

#chdir($tdir);

# Read kymesonet sites, build @sites and @timezones
&read_kym_sites;


$i = 0;
$j = 0;

foreach $site(@sites)
{
 $tbname = $site . "_H";
 $file = $tdir . $tbname . ".csv";
 print "\n$file\n";
 
 open (INFILE,"$file");

 while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);
    #print "$line\n";
    
    ($utme,$ltme,$tair,$dprc,$relh,$tdpt,$wspd,$wdir,$wsmx,$srad) = split(/\,/,$line);
    
    &check_db_data;

    # Insert/update db "kymesonet" 
    if (!@query_out) { &insert_db; }
    #else { &update_db; }

 }

 close(INFILE);
 
 $i++; 
 sleep(2); 
 #if ($i > 0){ last; }
  
}



#
$con ->disconnect;


print "\n";
print " Total sites $i, $j lines updated!\n\n";


##



# Check data in the database
sub check_db_data
{
	
$query = "select * from $tbname where utme=$utme";
$sth = $con -> prepare($query);
$sth->execute;

@query_out = $sth->fetchrow_array;
$sth->finish;
	
}	

# Insert data to msql db
sub insert_db
{

# Insert data  
$query = "INSERT INTO `$database`.`$tbname` (`utme`, `ltme`, `tair`, `dprc`, `relh`, `tdpt`, `wspd`, `wdir`, `wsmx`, `srad`)
VALUES ('$utme', '$ltme', '$tair', '$dprc', '$relh', '$tdpt', '$wspd', '$wdir', '$wsmx', '$srad')";


   
#mysql_query("INSERT INTO $tbname (`utme`, `ltme`, `tair`, `dprc`, `relh`, `tdpt`, `wspd`, `wdir`, `wsmx`, `srad`)
#VALUES ('$utme', '$ltme', '$tair', '$dprc', '$relh', '$tdpt', '$wspd', '$wdir', '$wsmx', '$srad')");	


# Update 
#mysql_query("UPDATE `$database`.`$table` SET xtmx=$dd[2], xtmn=$dd[3], xprc=$dd[4], xhmx=$dd[5], xhmn=$dd[6], xatd=$dd[7], 
#xwsa=$dd[8], xwsa=$dd[9] WHERE `stid`=$dd[0] and ltme=STR_TO_DATE('$dd[1]'") or die(mysql_error());   
#echo "  --updated.<br>";    


#$query = "insert into $tbname values \(";
#$query .= sprintf("%10s,",$utme);
#$query .= sprintf("%10s,",$ltme);
#$query .= sprintf("%6s,",$tair);
#$query .= sprintf("%6s,",$dprc);
#$query .= sprintf("%4s,",$relh);
#$query .= sprintf("%6s,",$tdpt);
#$query .= sprintf("%6s,",$wspd);
#$query .= sprintf("%4s,",$wdir);
#$query .= sprintf("%6s,",$wsmx);
#$query .= sprintf("%8s",$srad);
#
#$query .= "\)";

#print "$query\n";
print ".";

if ($utme =~ /^\d+$/ && $utme > 2000000000){ 
    $con->do($query);
    $j++;
}

}

# Replace -1.0 or 999 or 999.9 with following observation
sub update_db
{
# update $tbname set tair=50.9 where utme=$utme
$j = 0;    
foreach $ss(@query_out){
    	  if ($ss =~ /-1.0/||$ss =~ /999/||$ss =~ /999.9/){
    	      #print "$j:$ss\n";   	          	      
            $dd = $dbdata[$j];
            $dd1 = ${$dd};
            
            if ($dd1 != -1.0 && $dd1 != 999 && $dd1 != 999.9){ 
                  
                  $query = "update $tbname set ";
            	    $query .= "$dd=$dd1";
            	    $query .= " where utme=$utme";
            	    
            	    print "$query\n";
            	    #$con->do($query);
            }

    	  }	
    	  $j++;   
}
	
}

#
sub read_kym_sites
{
$kym_sites = "/data/ldm/data/kymesonet/scripts/kymesonet_sites";

open (INFILE,"$kym_sites");

$line = <INFILE>;

while (!eof(INFILE)) {
    $line = <INFILE>;
    chomp($line);

    ($co,$site,$tm) = split(/\s+/,$line);
    #print "$co,$site,$tm\n";

    push(@sites,$site);
    #$timezones{$site} = $tm;
    #print "$site,$timezones{$site}\n";
    #print "$site\n";

}

close(INFILE);

}
