#!/usr/bin/perl
#

use Scalar::Util qw(looks_like_number);

$ss = "2008-02-15 10:10:00";
print "$ss\n";

@str = $ss =~ /(\d+)/g;
print "@str\n";
#$ss = "@str";
$ss = "$str[0]$str[1]$str[2]$str[3]";
print "$ss\n";


print "Test if a string is a number\n\n";

$test = "123.30";

print "the string is $test\n";

if ($test!~ /\D/) { 
 print "String contains only digits";
} else {
 print "String contains other characters";
}

print "\n\n";


my @exprs = qw(1 5.25 0.001 1.3e8 foo bar 1dd);

print "The string @exprs\n";


foreach my $expr (@exprs) {
    print "$expr is", looks_like_number($expr) ? '' : ' not', " a number\n";

    if (!looks_like_number($expr)){ print "Not a number: $expr\n\n"; }
}


print "\n\n";

$xatd = "10.5";
#$xatd = "nan";
print "the string : $xatd\n";

if (!looks_like_number($xatd)){ $xatd = 999.9; }
else { $xatd = 32 + 1.8 * $xatd;  }
$xatd = sprintf("%5.1f",$xatd);

print "$xatd\n\n";


if ($xatd !~ /^-?\d+\.?\d*$/){ $xatd = 999.9; }
print "$xatd\n\n";



use Regexp::Common;
if ($xatd !~ /$RE{num}{real}/) { $xatd = 999.9; }
print "$xatd\n\n";





